<?php
defined('TYPO3_MODE') or die ('Access denied.');

call_user_func(function ($extension, $table) {
    $registeredPlugin = \TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
        $extension,
        'Plugin',
        'LLL:EXT:' . $extension . '/Resources/Private/Language/locallang_be.xlf:example.title'
    ) ?: 'exampleextension_plugin';

    $GLOBALS['TCA'][$table]['types']['list']['subtypes_excludelist'][$registeredPlugin] = 'layout, pages, recursive, select_key';
    $GLOBALS['TCA'][$table]['types']['list']['subtypes_addlist'][$registeredPlugin] = 'pi_flexform';
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
        $registeredPlugin,
        'FILE:EXT:' . $extension . '/Configuration/FlexForm/PluginConfiguration.xml'
    );

    // Working example:
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTCAcolumns($table, [
        $extension . '_working_example' => [
            'label' => 'Working example',
            'config' => [
                'type' => 'select',
                'size' => 6,
                'minitems' => 0,
                'maxitems' => 99,
                'multiple' => true,
                'renderType' => 'selectCheckBox',
                'items' => [
                    ['Header #1', '--div--'],
                    ['Test Value #1', '1'],
                    ['Header #2', '--div--'],
                    ['Test Value #2', '2'],
                    ['Test Value #3', '3'],
                ],
            ]
        ],
    ]);
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes($table, $extension . '_working_example', 'list', 'after:list_type');

}, 'example_extension', 'tt_content');
